#! /bin/bash
############################################################################
##                                                                        ##
##     Copyright (C) 2010-2011  YannUbuntu (yannubuntu@gmail.com)         ##
##                                                                        ##
## This program is free software: you can redistribute it and/or modify   ##
## it under the terms of the GNU General Public License as published by   ##
## the Free Software Foundation, either version 3 of the License, or      ##
## (at your option) any later version.                                    ##
##                                                                        ##
## This program is distributed in the hope that it will be useful,        ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
## GNU General Public License for more details.                           ##
##                                                                        ##
## You should have received a copy of the GNU General Public License      ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>.  ##
##                                                                        ##
############################################################################
## Special thanks to Babdu89 and GRUB devs.
## LIBRAIRIES FOR OS-UNINSTALLER AND BOOT REPAIR
## http://ubuntuforums.org/showthread.php?t=1615667

show_tab_grub_location() {
if [[ "$1" = "on" ]];then
	echo 'SET@_tab_grub_location.set_sensitive(True)'; echo 'SET@_vbox_grub_location.show()'
else
	echo 'SET@_tab_grub_location.set_sensitive(False)'; echo 'SET@_vbox_grub_location.hide()'
fi
}

############ Separate boot part
_checkbutton_separateboot() {
RETOURCOMBO_SEPBUT=${@}; echo "[debug]RETOURCOMBO_SEPBUT becomes $RETOURCOMBO_SEPBUT"
if [[ ${RETOURCOMBO_SEPBUT} = True ]]; then
	USE_SEPARATEBOOTPART="yes"; echo 'SET@_combobox_separateboot.set_sensitive(True)'
else
	USE_SEPARATEBOOTPART="no"; echo 'SET@_combobox_separateboot.set_sensitive(False)'
fi
echo "[debug]USE_SEPARATEBOOTPART becomes : $USE_SEPARATEBOOTPART"
}

separate_bootpart_show_hide() {
# Input : PART_TO_REINSTALL_GRUB or PART_TO_REINSTALL_GRUB_PURGE
INPUTSEPBOOTPART="$1"

combobox_separateboot_fillin


FORCE_PARTITION="${LISTOFPARTITIONS[$INPUTSEPBOOTPART]}"
echo "SET@_label_force_grub.set_text('''${Force_GRUB_into} ${FORCE_PARTITION} (${for_chainloader})''')"
echo "SET@_label_is_removable_disk.set_text('''${DISK_PART[$INPUTSEPBOOTPART]} ${is_a_removable_disk}''')"
fill_combobox_place_grub $INPUTSEPBOOTPART

echo "[debug]separate_bootpart and efi show_hide ${LISTOFPARTITIONS[$INPUTSEPBOOTPART]}" # mapper debug
if [[ "$QTY_PARTWITHOUTOS" = "0" ]];then
	USE_SEPARATEBOOTPART="no"
	echo 'SET@_vbox_separateboot.hide()'
	if [[ "$MBR_ACTION" = "reinstall" ]] && [[ "${BOOTPRESENCE_OF_PART[$INPUTSEPBOOTPART]}" = "no boot" ]];then
		zenity --error --title="$(eval_gettext "$CLEANNAME")" --text="Error : please choose the [Purge GRUB] option and report this bug to the developper of this software."
	fi
else
	echo 'SET@_vbox_separateboot.show()'
	if [[ "$MBR_ACTION" = "reinstall" ]] && [[ "${BOOTPRESENCE_OF_PART[$INPUTSEPBOOTPART]}" = "no boot" ]];then
		USE_SEPARATEBOOTPART="yes"
		echo 'SET@_checkbutton_separateboot.set_active(True)'
	else
		USE_SEPARATEBOOTPART="no"
		echo 'SET@_combobox_separateboot.set_sensitive(False)'
		echo 'SET@_checkbutton_separateboot.set_active(False)'
	fi
fi
separate_efi_show_hide
}

combobox_separateboot_fillin() {
echo "[debug]combobox_separateboot_fillin"
echo "COMBO@@CLEAR@@_combobox_separateboot"
#In priority sep boot located on the same disk
QTY_PARTWITHOUTOS=0
for typecsbf in "is-sepboot" "is-maybe-sepboot";do
	for lup in 1 2;do
		for ((csbf=1;csbf<=NBOFPARTITIONS;csbf++)); do
			if [[ "${PART_WITH_SEPARATEBOOT[$csbf]}" = "$typecsbf" ]];then
				if [[ "$lup" = "1" ]] && [[ "${DISK_PART[$INPUTSEPBOOTPART]}" = "${DISK_PART[$csbf]}" ]];then
					(( QTY_PARTWITHOUTOS += 1 ))
					LIST_PARTWITHOUTOS[$QTY_PARTWITHOUTOS]="$csbf"
				elif [[ "$lup" = "2" ]] && [[ "${DISK_PART[$INPUTSEPBOOTPART]}" != "${DISK_PART[$csbf]}" ]];then
					(( QTY_PARTWITHOUTOS += 1 ))
					LIST_PARTWITHOUTOS[$QTY_PARTWITHOUTOS]="$csbf"
				fi
			fi
		done
	done
done
while read fichier; do echo "SET@_combobox_separateboot.append_text('''${fichier}''')";done < <( for ((icsf=1;icsf<=QTY_PARTWITHOUTOS;icsf++)); do
	echo "${LISTOFPARTITIONS[${LIST_PARTWITHOUTOS[$icsf]}]}"
done)
echo 'SET@_combobox_separateboot.set_active(0)'; BOOTPART_TO_USE="${LIST_PARTWITHOUTOS[1]}"
}

_combobox_separateboot() {
RETOURCOMBO_separateboot="${@}"
echo "[debug]RETOURCOMBO_separateboot (BOOTPART_TO_USE) : $RETOURCOMBO_separateboot"
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	[[ "$RETOURCOMBO_separateboot" = "${LISTOFPARTITIONS[$i]}" ]] && BOOTPART_TO_USE="$i"
done
}

############## EFI
_checkbutton_efi() {
RETOUREFI=${@}
if [[ ${RETOUREFI} = True ]]; then
	if [[ "$EFIDMESG" != "EFIsession" ]];then
		MODE1=BIOS; MODE2=EFI; update_translations
		zenity --info --title="$(eval_gettext "$CLEANNAME")" --text="${Boot_is_MODE1_change_to_MODE2} ${Then_try_again}"
		GRUBPACKAGE="grub2"; echo 'SET@_checkbutton_efi.set_active(False)'
	else
		GRUBPACKAGE="grub-efi"; echo 'SET@_combobox_efi.set_sensitive(True)'
		if [[ "${APTTYP[$PART_TO_REINSTALL_GRUB_PURGE]}" = "apt-get" ]];then
			LASTGRUB_ACTION="yes"; echo 'SET@_checkbutton_lastgrub.set_active(True)'
		fi
	fi
else
	GRUBPACKAGE="grub2"; echo 'SET@_combobox_efi.set_sensitive(False)'
fi
echo "[debug]GRUBPACKAGE becomes : $GRUBPACKAGE"
}

_combobox_efi() {
RETOURCOMBO_efi="${@}"
echo "[debug]RETOURCOMBO_efi (EFIPART_TO_USE) : $RETOURCOMBO_efi"
for ((i=1;i<=NBOFPARTITIONS;i++)); do
	[[ "$RETOURCOMBO_efi" = "${LISTOFPARTITIONS[$i]}" ]] && EFIPART_TO_USE="$i"
done
echo "[debug]EFIPART_TO_USE becomes : $EFIPART_TO_USE"
}

combobox_efi_fillin() {
# Input : INPUTSEPBOOTPART (PART_TO_REINSTALL_GRUB or PART_TO_REINSTALL_GRUB_PURGE)
echo "[debug]combobox_efi_fillin ${LISTOFPARTITIONS[$INPUTSEPBOOTPART]}"
QTY_EFIPART=0
QTY_SUREEFIPART=0
for lup in 1 2 3 4;do
	for ((icef=1;icef<=NB_BISEFIPART;icef++)); do
		temp=""
		if [[ "${DISK_PART[${BISEFIPART[$icef]}]}" = "${DISK_PART[$INPUTSEPBOOTPART]}" ]];then
			if [[ "$lup" = "1" ]] && [[ "${BISEFIPART[$icef]}" = "${EFI_OF_PART[$INPUTSEPBOOTPART]}" ]];then
				temp="ok" #by default EFI part (detected by BIS and in fstab) in same disk
				(( QTY_SUREEFIPART += 1 ))
			elif [[ "$lup" = "2" ]] && [[ "${BISEFIPART[$icef]}" != "${EFI_OF_PART[$INPUTSEPBOOTPART]}" ]];then
				temp="ok" #then EFI part (detected by BIS but not in fstab) in same disk
				(( QTY_SUREEFIPART += 1 ))
			fi
		else
			if [[ "$lup" = "3" ]] && [[ "${BISEFIPART[$icef]}" = "${EFI_OF_PART[$INPUTSEPBOOTPART]}" ]];then
				temp="ok" #then EFI part (detected by BIS and in fstab) in another disk
			elif [[ "$lup" = "4" ]] && [[ "${BISEFIPART[$icef]}" != "${EFI_OF_PART[$INPUTSEPBOOTPART]}" ]];then
				temp="ok" #then EFI part (detected by BIS but not in fstab) in another disk
			fi
		fi
		if [[ "$temp" = "ok" ]];then
			(( QTY_EFIPART += 1 ))
			LIST_EFIPART[$QTY_EFIPART]="${BISEFIPART[$icef]}"
		fi
	done
done
for ((icef=1;icef<=NBOFPARTITIONS;icef++)); do # At last, parts not detected as EFI by BIS
	if [[ "${BIS_EFI_TYPE[$icef]}" != "BISEFI" ]];then
		(( QTY_EFIPART += 1 ))
		LIST_EFIPART[$QTY_EFIPART]="${icef}"
	fi
done
echo "COMBO@@CLEAR@@_combobox_efi"
while read fichier; do echo "SET@_combobox_efi.append_text('''${fichier}''')";done < <( for ((icef=1;icef<=QTY_EFIPART;icef++)); do
	echo "${LISTOFPARTITIONS[${LIST_EFIPART[$icef]}]}"
done)
echo 'SET@_combobox_efi.set_active(0)'; EFIPART_TO_USE="${LIST_EFIPART[1]}"
}

separate_efi_show_hide() {
echo "[debug]efi_show_hide $INPUTSEPBOOTPART (${GPTTYPE[$INPUTSEPBOOTPART]})" # mapper debug
combobox_efi_fillin
GRUBPACKAGE="grub2"
if [[ "$QTY_EFIPART" = "0" ]];then
	echo 'SET@_vbox_efi.hide()'
else
	echo 'SET@_vbox_efi.show()'
	if [[ "$MBR_ACTION" = "reinstall" ]];then
		echo 'SET@_checkbutton_efi.set_sensitive(False)'
		echo 'SET@_checkbutton_efi.set_active(False)'
		echo 'SET@_combobox_efi.set_sensitive(False)'
	else
		echo 'SET@_checkbutton_efi.set_sensitive(True)'
		if [[ "$QTY_SUREEFIPART" = "0" ]];then
			echo 'SET@_combobox_efi.set_sensitive(False)'
			echo 'SET@_checkbutton_efi.set_active(False)'
		else #if EFI part detected by BIS on same disk as GRUB
			GRUBPACKAGE="grub-efi"
			echo 'SET@_checkbutton_efi.set_active(True)'
		fi
	fi
fi
}

############### OS to boot by default
_combobox_ostoboot_bydefault() {
RETOURCOMBO_ostoboot_bydefault="${@}"
if [[ "$REINSTALL_POSSIBLE" = "yes" ]];then
	echo "[debug]RETOURCOMBO_ostoboot_bydefault : ${RETOURCOMBO_ostoboot_bydefault}"
	for ((i=1;i<=QTY_OF_PART_FOR_REINSTAL;i++)); do 
		echo "[debug]${LABEL_PART_FOR_REINSTAL[${LIST_OF_PART_FOR_REINSTAL[$i]}]}"
		if [[ "$RETOURCOMBO_ostoboot_bydefault" =~ "${LISTOFPARTITIONS[${LIST_OF_PART_FOR_REINSTAL[$i]}]} " ]];then
			if [[ "$LIVESESSION" != "yes" ]] && [[ "$i" != "1" ]];then
				zenity --info --timeout=3 --title="$(eval_gettext "$CLEANNAME")" --text="$Please_use_in_live_session $This_will_enable_this_feature"
				echo 'SET@_combobox_ostoboot_bydefault.set_active(0)'
			elif [[ "${ARCH_OF_PART[${LIST_OF_PART_FOR_REINSTAL[$i]}]}" = "64" ]] && [[ "$(uname -m)" != "x86_64" ]] && [[ "$i" != "1" ]];then
				zenity --info --timeout=3 --title="$(eval_gettext "$CLEANNAME")" --text="$Please_use_in_a_64bits_session $This_will_enable_this_feature"
				echo 'SET@_combobox_ostoboot_bydefault.set_active(0)'
			else
				PART_TO_REINSTALL_GRUB="${LIST_OF_PART_FOR_REINSTAL[$i]}"
				separate_bootpart_show_hide $PART_TO_REINSTALL_GRUB
			fi
		fi
	done
fi
}

combobox_ostoboot_bydefault_fillin() {
echo "[debug]combobox_ostoboot_bydefault_fillin"
REINSTALL_POSSIBLE="no"
if [[ "$QTY_OF_PART_WITH_GRUB" != "0" ]];then

	QTY_OF_PART_FOR_REINSTAL=0
	if [[ "$(uname -m)" != "x86_64" ]];then
		echo "[debug]Order Linux according to their arch type"
		loop_ostoboot_bydefault_fillin 64
		loop_ostoboot_bydefault_fillin 32
	else
		loop_ostoboot_bydefault_fillin noorder
	fi
	for ((i=1;i<=QTY_OF_PART_FOR_REINSTAL;i++)); do
		LABEL_PART_FOR_REINSTAL[$i]="${LISTOFPARTITIONS[${LIST_OF_PART_FOR_REINSTAL[$i]}]}"
		for ((j=1;j<=TOTAL_QUANTITY_OF_OS;j++)); do  
			if [[ "${OS_PARTITION[$j]}" = "${LISTOFPARTITIONS[${LIST_OF_PART_FOR_REINSTAL[$i]}]}" ]]; then
				LABEL_PART_FOR_REINSTAL[$i]="${OS_PARTITION[$j]} \(${OS_NAME[$j]}\)"
			fi
		done
		echo "[debug]LABEL_PART_FOR_REINSTAL[$i] ${LABEL_PART_FOR_REINSTAL[$i]}"
	done
	while read fichier; do echo "SET@_combobox_ostoboot_bydefault.append_text('''${fichier}''')";done < <( for ((i=1;i<=QTY_OF_PART_FOR_REINSTAL;i++)); do
		echo "${LABEL_PART_FOR_REINSTAL[$i]}"
	done)
fi
if [[ "$NB_BISEFIPART" != "0" ]] || [[ "$EFIDMESG" = "EFIsession" ]];then
	REINSTALL_POSSIBLE="no" #Force purge if EFI detected
fi 
if [[ "$REINSTALL_POSSIBLE" = "yes" ]];then
	echo 'SET@_hbox_ostoboot_bydefault.set_sensitive(True)'
	echo 'SET@_combobox_ostoboot_bydefault.set_active(0)'
	PART_TO_REINSTALL_GRUB="${LIST_OF_PART_FOR_REINSTAL[1]}"
	INPUTSEPBOOTPART="$PART_TO_REINSTALL_GRUB"
	combobox_efi_fillin	#Hide/show efi boot

	###### Combo_place_grub fillin (Place into) ######
	fill_combobox_place_grub $PART_TO_REINSTALL_GRUB

	###### Combo_place_alldisks fillin (Place GRUB in all MBR) ####
	REMOVABLEDISK="no"; SHOW_REMOVABLEDISK="no"
	if [[ "$NBOFDISKS" != "1" ]];then
		echo 'SET@_radiobutton_place_alldisks.show()'
		for ((i=1;i<=TOTAL_QUANTITY_OF_OS;i++)); do
			if [[ "${OS_DISK[$i]}" != "${DISK_PART[$PART_TO_REINSTALL_GRUB]}" ]] && [[ "$SHOW_REMOVABLEDISK" = "no" ]];then
				#It exists another disk with OS
				echo 'SET@_vbox_is_removable_disk.show()'
				echo "SET@_label_is_removable_disk.set_text('''${DISK_PART[$PART_TO_REINSTALL_GRUB]} ${is_a_removable_disk}''')"
				SHOW_REMOVABLEDISK="yes" #To finish the loop
			fi
		done
	else
		echo 'SET@_radiobutton_place_alldisks.hide()'
	fi

	# Combo_force_grub fillin (Force GRUB into) #########
	FORCE_PARTITION="${LISTOFPARTITIONS[${PART_TO_REINSTALL_GRUB}]}"
	echo "SET@_label_force_grub.set_text('''${Force_GRUB_into} ${FORCE_PARTITION} (${for_chainloader})''')"
else
	echo 'SET@_hbox_ostoboot_bydefault.set_sensitive(False)'
fi
}

loop_ostoboot_bydefault_fillin() {
tmparch=$1
if [[ "$LIVESESSION" != "yes" ]];then
	for ((ilobf=1;ilobf<=QTY_OF_PART_WITH_GRUB;ilobf++)); do
		if [[ "$QTY_BOOTPART" != "0" ]] || [[ "${BOOTPRESENCE_OF_PART[${LIST_OF_PART_WITH_GRUB[$ilobf]}]}" != "no boot" ]] && [[ "${LISTOFPARTITIONS[${LIST_OF_PART_WITH_GRUB[$ilobf]}]}" != "$OS_TO_DELETE_PARTITION" ]] && [[ "${ARCH_OF_PART[${LIST_OF_PART_WITH_GRUB[$ilobf]}]}" != "$tmparch" ]] && [[ "${ARCH_OF_PART[${LIST_OF_PART_WITH_GRUB[$ilobf]}]}" ]];then
			(( QTY_OF_PART_FOR_REINSTAL += 1 ))
			LIST_OF_PART_FOR_REINSTAL[$QTY_OF_PART_FOR_REINSTAL]="${LIST_OF_PART_WITH_GRUB[$ilobf]}"
			REINSTALL_POSSIBLE="yes"		
		fi
	done
else
	for grubtmp in grub2 grub;do #put GRUB2 Linux in priority
		echo "[debug]Order Linux according to their /boot type $tmparch bits"
		for bootyp in "with boot" "maybe separate" "no boot";do
			for ((ilobf=1;ilobf<=QTY_OF_PART_WITH_GRUB;ilobf++)); do
				if [[ "${GRUBVER[${LIST_OF_PART_WITH_GRUB[$ilobf]}]}" = "$grubtmp" ]];then
					temp=""
					if [[ "${BOOTPRESENCE_OF_PART[${LIST_OF_PART_WITH_GRUB[$ilobf]}]}" = "$bootyp" ]] && [[ "${LISTOFPARTITIONS[${LIST_OF_PART_WITH_GRUB[$ilobf]}]}" != "$OS_TO_DELETE_PARTITION" ]] && [[ "${ARCH_OF_PART[${LIST_OF_PART_WITH_GRUB[$ilobf]}]}" != "$tmparch" ]] && [[ "${ARCH_OF_PART[${LIST_OF_PART_WITH_GRUB[$ilobf]}]}" ]];then
						if [[ "$bootyp" = "with boot" ]];then
							temp=ok
						elif [[ "$bootyp" = "maybe separate" ]] && [[ "$QTY_PARTWITHOUTOS" != "0" ]];then
							temp=ok
						elif [[ "$bootyp" = "no boot" ]] && [[ "$QTY_BOOTPART" != "0" ]];then
							temp=ok
						fi
						if [[ "$temp" = "ok" ]];then
							(( QTY_OF_PART_FOR_REINSTAL += 1 ))
							LIST_OF_PART_FOR_REINSTAL[$QTY_OF_PART_FOR_REINSTAL]="${LIST_OF_PART_WITH_GRUB[$ilobf]}"
							REINSTALL_POSSIBLE="yes"
						fi		
					fi
				fi
			done
		done
	done
fi
}


_radiobutton_ostoboot_bydefault() {
RETOUROSTOB=${@}
if [[ ${RETOUROSTOB} = True ]];then
	set_radiobutton_ostoboot_bydefault
	if [[ "$GRUBVER[$PART_TO_REINSTALL_GRUB]" = "grub" ]];then
		echo "$This_will_install_an_obsolete_bootloader"
		zenity --warning --title="$(eval_gettext "$CLEANNAME")" --text="$This_will_install_an_obsolete_bootloader (GRUB Legacy)."
	fi
fi
}

set_radiobutton_ostoboot_bydefault() {
echo "[debug]set_radiobutton_ostoboot_bydefault"
echo 'SET@_combobox_ostoboot_bydefault.set_sensitive(True)'
echo 'SET@_combobox_purge_grub.set_sensitive(False)'
MBR_ACTION="reinstall"; echo "[debug]MBR_ACTION is set : $MBR_ACTION (NBOFDISKS is $NBOFDISKS)"
echo 'SET@_checkbutton_ata.show()'
echo 'SET@_checkbutton_lastgrub.set_sensitive(False)'
echo 'SET@_checkbutton_lastgrub.set_active(False)'
#echo 'SET@_vbox_place_or_force.show()'
echo 'SET@_button_open_etc_default_grub.show()'
set_bottom_tab_loca $PART_TO_REINSTALL_GRUB
}

set_bottom_tab_loca() {
TMPPART=$1
separate_bootpart_show_hide $TMPPART
if [[ "$NBOFDISKS" != "1" ]] && [[ ! "${LISTOFPARTITIONS[$TMPPART]}" =~ "mapper/" ]];then #RAID is broken if install GRUB in sdX
	echo 'SET@_radiobutton_place_alldisks.set_active(True)'; set_radiobutton_place_alldisks
else
	echo 'SET@_radiobutton_place_alldisks.hide()'
	echo 'SET@_radiobutton_place_grub.set_active(True)'; set_radiobutton_place_grub
fi
}

############################ Purge GRUB ####################################
combobox_purge_grub_fillin() {
if [[ "$QTY_OF_PART_WITH_APTGET" != "0" ]];then
	QTY_OF_PART_FOR_PURGE=0
	if [[ "$(uname -m)" != "x86_64" ]];then
		loop_purge_grub_fillin 64
		loop_purge_grub_fillin 32
	else
		loop_purge_grub_fillin noorder
	fi
	for ((i=1;i<=QTY_OF_PART_FOR_PURGE;i++)); do
		LABEL_PART_FOR_PURGE[$i]="${LISTOFPARTITIONS[${LIST_OF_PART_FOR_PURGE[$i]}]}"
		for ((j=1;j<=TOTAL_QUANTITY_OF_OS;j++)); do  
			if [[ "${OS_PARTITION[$j]}" = "${LISTOFPARTITIONS[${LIST_OF_PART_FOR_PURGE[$i]}]}" ]]; then
				LABEL_PART_FOR_PURGE[$i]="${OS_PARTITION[$j]} \(${OS_NAME[$j]}\)"
			fi
		done
		echo "[debug]LABEL_PART_FOR_PURGE[$i] ${LABEL_PART_FOR_PURGE[$i]}"
	done
	while read fichier; do echo "SET@_combobox_purge_grub.append_text('''${fichier}''')";done < <( for ((i=1;i<=QTY_OF_PART_FOR_PURGE;i++)); do
		echo "${LABEL_PART_FOR_PURGE[$i]}"
	done)
fi
if [[ "$PURGE_POSSIBLE" = "yes" ]];then
	echo 'SET@_hbox_purge_grub.set_sensitive(True)'
	echo 'SET@_combobox_purge_grub.set_active(0)'
	PART_TO_REINSTALL_GRUB_PURGE="${LIST_OF_PART_FOR_PURGE[1]}"
else
	echo 'SET@_hbox_purge_grub.set_sensitive(False)'
fi
}

loop_purge_grub_fillin() {
tmparch=$1
if [[ "$LIVESESSION" != "yes" ]];then
	for ((lpgf=1;lpgf<=QTY_OF_PART_WITH_APTGET;lpgf++)); do
		if [[ "${ARCH_OF_PART[${LIST_OF_PART_WITH_APTGET[$lpgf]}]}" != "$tmparch" ]] && [[ "${ARCH_OF_PART[${LIST_OF_PART_WITH_APTGET[$lpgf]}]}" ]] && [[ "${LISTOFPARTITIONS[${LIST_OF_PART_WITH_APTGET[$lpgf]}]}" != "$OS_TO_DELETE_PARTITION" ]];then
			(( QTY_OF_PART_FOR_PURGE += 1 ))
			LIST_OF_PART_FOR_PURGE[$QTY_OF_PART_FOR_PURGE]="${LIST_OF_PART_WITH_APTGET[$lpgf]}"
			PURGE_POSSIBLE="yes"	
		fi
	done
else
	for grubtmp in grub2 grub;do #put GRUB2 Linux in priority
		echo "[debug]Order purge Linux according to their /boot type $tmparch bits"
		for bootyp in "with boot" "maybe separate" "no boot";do
			for ((ilobf=1;ilobf<=QTY_OF_PART_WITH_APTGET;ilobf++)); do
				if [[ "${GRUBVER[${LIST_OF_PART_WITH_APTGET[$ilobf]}]}" = "$grubtmp" ]];then
					temp=""
					if [[ "${BOOTPRESENCE_OF_PART[${LIST_OF_PART_WITH_APTGET[$ilobf]}]}" = "$bootyp" ]] && [[ "${LISTOFPARTITIONS[${LIST_OF_PART_WITH_APTGET[$ilobf]}]}" != "$OS_TO_DELETE_PARTITION" ]] && [[ "${ARCH_OF_PART[${LIST_OF_PART_WITH_APTGET[$ilobf]}]}" != "$tmparch" ]] && [[ "${ARCH_OF_PART[${LIST_OF_PART_WITH_APTGET[$ilobf]}]}" ]];then
						if [[ "$bootyp" = "with boot" ]];then
							temp=ok
						elif [[ "$bootyp" = "maybe separate" ]];then
							temp=ok
						elif [[ "$bootyp" = "no boot" ]];then
							temp=ok
						fi
						if [[ "$temp" = "ok" ]];then
							(( QTY_OF_PART_FOR_PURGE += 1 ))
							LIST_OF_PART_FOR_PURGE[$QTY_OF_PART_FOR_PURGE]="${LIST_OF_PART_WITH_APTGET[$ilobf]}"
							PURGE_POSSIBLE="yes"
						fi		
					fi
				fi
			done
		done
	done
fi
}


_radiobutton_purge_grub() {
RETOURPURGEG=${@}
if [[ ${RETOURPURGEG} = True ]]; then
	echo 'SET@_button_mainapply.set_sensitive(False)' #To avoid applying before variables are changed
	[[ "$INTERNET" != "connected" ]] && check_internet_connection
	if [[ "$INTERNET" = "connected" ]];then
		echo 'SET@_combobox_purge_grub.set_sensitive(True)'
		echo 'SET@_combobox_ostoboot_bydefault.set_sensitive(False)'
		#echo 'SET@_vbox_place_or_force.hide()'
		echo 'SET@_button_open_etc_default_grub.hide()'
		#echo 'SET@_checkbutton_ata.hide()'
		[[ "${APTTYP[$PART_TO_REINSTALL_GRUB_PURGE]}" = "apt-get" ]] &&	echo 'SET@_checkbutton_lastgrub.set_sensitive(True)'
		MBR_ACTION="purge"; echo "[debug]MBR_ACTION becomes : $MBR_ACTION"
		set_bottom_tab_loca $PART_TO_REINSTALL_GRUB_PURGE
	else
		echo "SET@_label_purge_grub.set_text('''${requires_internet}''')"
		sleep 1
		[[ "$MBR_ACTION" = "reinstall" ]] && echo 'SET@_radiobutton_ostoboot_bydefault.set_active(True)' || echo 'SET@_checkbutton_restore_mbr.set_active(True)'
		echo "SET@_label_purge_grub.set_text('''${Purge_and_reinstall_the_grub_of}''')"
	fi
	echo 'SET@_button_mainapply.set_sensitive(True)'
fi
}

_combobox_purge_grub() {
RETOURCOMBO_purge_grub="${@}"
if [[ "$PURGE_POSSIBLE" = "yes" ]];then
	echo "[debug]RETOURCOMBO_purge_grub : ${RETOURCOMBO_purge_grub}"
	for ((i=1;i<=QTY_OF_PART_FOR_PURGE;i++)); do 
		echo "[debug]${LISTOFPARTITIONS[${LIST_OF_PART_FOR_PURGE[$i]}]}"
		if [[ "$RETOURCOMBO_purge_grub" =~ "${LISTOFPARTITIONS[${LIST_OF_PART_FOR_PURGE[$i]}]} " ]];then
			if [[ "$LIVESESSION" != "yes" ]] && [[ "$i" != "1" ]];then
				zenity --info --timeout=3 --title="$(eval_gettext "$CLEANNAME")" --text="$Please_use_in_live_session $This_will_enable_this_feature"
				echo 'SET@_combobox_purge_grub.set_active(0)'
				separate_bootpart_show_hide $PART_TO_REINSTALL_GRUB_PURGE
			elif [[ "${ARCH_OF_PART[${LIST_OF_PART_FOR_PURGE[$i]}]}" != "32" ]] && [[ "$(uname -m)" != "x86_64" ]] && [[ "$i" != "1" ]];then
				zenity --info --timeout=3 --title="$(eval_gettext "$CLEANNAME")" --text="$Please_use_in_a_64bits_session $This_will_enable_this_feature"
				echo 'SET@_combobox_purge_grub.set_active(0)'
				separate_bootpart_show_hide $PART_TO_REINSTALL_GRUB_PURGE
			else
				PART_TO_REINSTALL_GRUB_PURGE="${LIST_OF_PART_FOR_PURGE[$i]}"
				echo "[debug]PART_TO_REINSTALL_GRUB_PURGE becomes $PART_TO_REINSTALL_GRUB_PURGE (${LISTOFPARTITIONS[$PART_TO_REINSTALL_GRUB_PURGE]})"
			fi
		fi
	done
fi
}

####################### Removable disk
_checkbutton_is_removable_disk() {
RETOURREMOV=${@}
[[ ${RETOURREMOV} = True ]] && REMOVABLEDISK="yes" || REMOVABLEDISK="no"
echo "[debug]REMOVABLEDISK becomes : $REMOVABLEDISK"
}

##################### Place all disks
_radiobutton_place_alldisks() {
RETOURPLACEALL=${@}
[[ ${RETOURPLACEALL} = True ]] && set_radiobutton_place_alldisks || echo 'SET@_vbox_is_removable_disk.hide()'
}

set_radiobutton_place_alldisks() {
[[ "$MBR_ACTION" = "purge" ]] && TEMPOPART=$PART_TO_REINSTALL_GRUB_PURGE || TEMPOPART=$PART_TO_REINSTALL_GRUB
echo "[debug]set_radiobutton_place_alldisks"
FORCE_GRUB="all"; echo "[debug]FORCE_GRUB becomes : $FORCE_GRUB"
for ((i=1;i<=QTY_OF_PART_WITH_GRUB;i++)); do
	[[ "${DISK_PART[$TEMPOPART]}" != "${DISK_PART[${LIST_OF_PART_WITH_GRUB[$i]}]}" ]] && echo 'SET@_vbox_is_removable_disk.show()'
done
}

###################### Place GRUB
_radiobutton_place_grub() {
RETOURPLACEG=${@}
[[ ${RETOURPLACEG} = True ]] && set_radiobutton_place_grub || echo 'SET@_combobox_place_grub.set_sensitive(False)'
}

set_radiobutton_place_grub() {
echo "[debug]set_radiobutton_place_grub"
echo 'SET@_combobox_place_grub.set_sensitive(True)'; FORCE_GRUB="no"; echo "[debug]FORCE_GRUB becomes : $FORCE_GRUB"
}

_combobox_place_grub() {
NOFORCE_DISK="${@}"
echo "[debug]RETOURCOMBO_place_grub (NOFORCE_DISK) : $NOFORCE_DISK"
}

fill_combobox_place_grub() {
NOFORCE_DISK="${DISK_PART[$1]}"
echo "COMBO@@CLEAR@@_combobox_place_grub"
while read fichier; do
	echo "SET@_combobox_place_grub.append_text('''${fichier}''')";
done < <( echo "${NOFORCE_DISK}";
for ((i=1;i<=NBOFDISKS;i++)); do
	[[ "${LISTOFDISKS[$i]}" != "${NOFORCE_DISK}" ]] && echo "${LISTOFDISKS[$i]}" #Propose by default the disk of PART_TO_REINSTALL_GRUB
done)
echo 'SET@_combobox_place_grub.set_active(0)'
}

######################## Force GRUB
_radiobutton_force_grub() {
RETOURFORCEG=${@}
if [[ ${RETOURFORCEG} = True ]]; then
	FORCE_GRUB="yes"; echo "[debug]FORCE_GRUB becomes : $FORCE_GRUB"
fi
}

